#####
###  Abracadabra Object - pre-configured objects with only one click
##   Copyright (C) 2002 Maik Jablonski (maik.jablonski@uni-bielefeld.de)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
##   along with this program; if not, write to the Free Software
###  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#####

from Globals import DTMLFile, InitializeClass
from urllib import quote
from re import sub

# This is used for cooking an Id out the title
# all keys are mapped to values

CharacterMapping = {
'':'ue','':'ae','':'oe',
'':'Ue','':'Ae','':'Oe',
'':'ss'
}

def _scriptWrapper(self,client,object_id,REQUEST):

       callObj = getattr(self.standard_object_folder,object_id)
       
       if callObj.meta_type=='Script (Python)':                 
           callObj._exec({'context':client, 'container':callObj.aq_parent, 'script':callObj, 'traverse_subpath':''},[],{})
       else:
           callObj(client,REQUEST)

       return(callObj)
        
def manage_addAbracadabraObject(self, id, object_id, title='', REQUEST=None, submit=None):
    """ Call a script object_id_ or 
        clone the object_id from the folder 'standard_object_folder'
        to the current container.
        Calls object_id_ on the new created object if exists."""
    
    # create an auto-id 
    # if auto_id-string is set in the standard_object_folder    
    
    auto_id=self.standard_object_folder.getProperty('auto_id',None)
    fmt = '%d'
    
    if type(auto_id)==type([]):

        autoIds=auto_id
	for line in autoIds:
		(objStr,fmtStr)=line.split(':',1)
		if objStr==object_id:
			fmt=fmtStr

    elif type(auto_id)==type(''):

	fmt = self.standard_object_folder.getProperty('auto_id','')

    elif type(auto_id)==type(0):

        tmpId=auto_id
	while hasattr(self,str(tmpId)):
		    tmpId = tmpId + 1
		    
        self.standard_object_folder.manage_changeProperties({'auto_id':tmpId+1})
	id=str(tmpId)
    
    if not id:

	# if %s is given as format, cook an Id out of Title

	if auto_id and fmt.find('%s')<>-1 and title<>'':
	    Title=title

	    # Substitute important characters
	    # before replacing invalid id-characters with underscores

	    for fromChar in CharacterMapping.keys():
		    Title=Title.replace(fromChar,CharacterMapping[fromChar])

            id = fmt % sub('[\W]+','_',Title)

	    # remove leading and ending underscores, 
	    # 'cause _ is a special character in ZOPE's namespace

	    id = sub('^_*|_*$','',id)

	# else create a number as Id
	
	elif auto_id:

    	    tmpId = len(self.objectIds())    

	    # to be sure: test and search for a free id...

	    while hasattr(self,fmt % tmpId): 
		    tmpId = tmpId + 1

	    id = fmt % tmpId

	else:
    	    id = str(id)    
    
    # Script-Call - obect_id ends on an underscore, so call it as a script
    
    if object_id[-1]=='_':

       context=self
       callObj=_scriptWrapper(self,context,object_id,self.REQUEST)
       
    # Clone-Call - object_id ends on no underscore, so copy the object
    
    else:
       context=self.manage_clone(getattr(self.standard_object_folder,object_id),id,self.REQUEST)
       context.title=str(title)
        
       # Test if a corresponding object_id with an underscore exists
       # and call it
           
       if hasattr(self.standard_object_folder,object_id+'_'):
             callObj = _scriptWrapper(self,context,object_id+'_',self.REQUEST)

                        
    if REQUEST:
        try: u=self.DestinationURL()
        except: u=REQUEST['URL1']

        if submit==" Add and Edit Properties ":
            if hasattr(context.aq_explicit,'manage_propertiesForm'):
                u="%s/%s/manage_propertiesForm" % (u,quote(id))
            else:
                u="%s/%s/manage_main" % (u,quote(id))
                
        elif submit==" Add and Edit ":
            u="%s/%s/manage_main" % (u,quote(id))

        else:
            u="%s/manage_main" % (u)
                
        REQUEST.RESPONSE.redirect(u)

    return id
       
           
manage_addAbracadabraObjectForm = DTMLFile('dtml/addAbracadabraObject', globals())

class AbracadabraObject:
    """ AbracadabraObject - pre-configured objects with only one click """

    meta_type="Abracadabra Object"
    __ac_permissions__=( (('Abracadabra Object: Show StandardSelectBox'),()),)
    
InitializeClass(AbracadabraObject)
